package data;

/* Charge Control Version 1.1 (c) 2008 by Malte Marwedel

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import control.Tools;

public class BinDataEntry extends DataEntry{

	
	private int value;
	
	/**
	 *  The format is:
	 * "I:X;YYYYY;
	 * 
	 * @param str see above
	 */
	public BinDataEntry(String str) {
		super("I:0;00000;0000");
		value = Integer.valueOf(str.substring(4, 9));
	}
	
	public BinDataEntry(int i) {
		super("I:0;00000;0000");
		value = i;
	}

	public String getAsString() {
		return new String("I:4;"+Tools.intToStr(value, 5));
	}

	public int getCurrent() {
		return 0;
	}

	public int getMode() {
		return 0;
	}

	public int getVoltage() {
		return value;
	}
	
	public int getPower() {
		return 0;
	}

}
