package data;

/* Charge Control Version 1.1 (c) 2008 by Malte Marwedel

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;

import control.Tools;

import model.RecordedData;

public class DsoData extends UsefulData implements RecordedData {

	//Information send on the beginning
	int chargingcurrent = -1;
	
	//Information send on the termination
	int charged = -1;

	public DsoData() {
		al = new ArrayList<DataEntry>();
	}

	public boolean add(byte[] arr) {
		for (int i = 0; i < arr.length; i++) {
			al.add(new BinDataEntry(arr[i]));
		}
		return true;
	}

	public void pushToStream(OutputStream outs) throws IOException {
		for (int i = 0; i < al.size(); i++) {
			outs.write((al.get(i).getAsString()+Tools.newline).getBytes());
		}
	}

  public String getDescription() {
    return new String("DSO Data");
  }

	@Override
	public String getAdvancedDescription() {
		String str = "DSO Data with "+al.size()+" data points";
		return str;
	}

	public int getBeginningPercent() {
		return sPercent;
	}

	public int getStoppedPercent() {
		return tPercent;
	}

	public boolean add(String str) {
		if (str.startsWith("I:4")) {
			DataEntry de = new BinDataEntry(str);
			al.add(de);
		} else
	  System.out.println("DsoData.add: Error: Invalid string");
	  return true;
  }

}
